//
//	Cu "wI2cRtc8564" RTC-8856 hCo
//		copyright (c) 2012,2013 T.Nakao    http://www.wsnak.com
//
//		Wire̕pKvBlׂ̈͂BCDR[h
//
//	12/04/14
//	120513 WiregpɕύX
//
/*
	<J\bh>

	void Init(void);															// 
	void setDate(uint8_t year, uint8_t mon, uint8_t day, uint8_t wkday);		// N,j ݒ
	void setTime(uint8_t hur, uint8_t min, uint8_t sec);						// b ݒ
	void readDate(uint8_t *year, uint8_t *mon, uint8_t *day, uint8_t *wkday);	// N,j ǂݏo
	void readTime(uint8_t *hur, uint8_t *min, uint8_t *sec);					// b ǂݏo
	void setAlarm(uint8_t day, uint8_t hur, uint8_t min);						// A[ ݒ
	uint8_t checkAlarm(void);													// A[`FbN
	void setClkOut(uint8_t frq);	// NbNo͒[q gݒ
	void AlmEnable(uint8_t wkd, uint8_t day, uint8_t hur, uint8_t min);			// A[Lڂ̐ݒ
	void AlmStop(void);	// A[~
*/

#include "wI2cRtc8564.h"
#include "Arduino.h"
#include "Wire.h"


//-----------------------------------------------------------
// RXgN^
//-----------------------------------------------------------
wI2cRtc8564::wI2cRtc8564()
{

}


//-----------------------------------------------------------
// 
//-----------------------------------------------------------
void wI2cRtc8564::init(void) {
	uint8_t ctrl1, ctrl2;

	slaveAddress = 0x51;			// RTC-8856 Œ

	ctrl1 = 0;
	ctrl2 = 0;
	Wire.beginTransmission(slaveAddress);
	Wire.write(rgCTRL1);	// WX^AhXݒ
	Wire.write(ctrl1);
	Wire.write(ctrl2);
	Wire.endTransmission();
}


//-----------------------------------------------------------
// N,j ݒ
//-----------------------------------------------------------
void wI2cRtc8564::setDate(uint8_t year, uint8_t mon, uint8_t day, uint8_t wkday, uint8_t bcdflg) {
	Wire.beginTransmission(slaveAddress);
	Wire.write(rgDAY);		// WX^AhXݒ
	if(bcdflg) {
		// BCDR[h
		Wire.write(day);
		Wire.write(wkday);
		Wire.write(mon);
		Wire.write(year);
	} else {
		// ̓oCi
		Wire.write( BinToBcd(day) );
		Wire.write( BinToBcd(wkday) );
		Wire.write( BinToBcd(mon) );
		Wire.write( BinToBcd(year) );
	}
	Wire.endTransmission();
}


//-----------------------------------------------------------
// b ݒ
//-----------------------------------------------------------
void wI2cRtc8564::setTime(uint8_t hur, uint8_t min, uint8_t sec, uint8_t bcdflg) {
	Wire.beginTransmission(slaveAddress);
	Wire.write(rgSEC);		// WX^AhXݒ
	if(bcdflg) {
		// BCDR[h
		Wire.write(sec);
		Wire.write(min);
		Wire.write(hur);
	} else {
		// ̓oCi
		Wire.write( BinToBcd(sec) );
		Wire.write( BinToBcd(min) );
		Wire.write( BinToBcd(hur) );
	}
	Wire.endTransmission();
}


//-----------------------------------------------------------
// N,j ǂݏo
//-----------------------------------------------------------
void wI2cRtc8564::readDate(uint8_t *year, uint8_t *mon, uint8_t *day, uint8_t *wkday, uint8_t bcdflg) {

	Wire.beginTransmission(slaveAddress);
	Wire.write(rgDAY);			// 擪AhXݒ
	Wire.endTransmission();

	Wire.requestFrom(slaveAddress, 4);
	if(bcdflg) {
		// BCDR[h
		*day   = Wire.read() & 0x3F;
		*wkday = Wire.read() & 0x07;
		*mon   = Wire.read() & 0x1F;
		*year  = Wire.read();
	} else {
		// ̓oCi
		*day   = BcdToBin( Wire.read() & 0x3F );
		*wkday = BcdToBin( Wire.read() & 0x07 );
		*mon   = BcdToBin( Wire.read() & 0x1F );
		*year  = BcdToBin( Wire.read() );
	}
}


//-----------------------------------------------------------
// b ǂݏo
//-----------------------------------------------------------
void wI2cRtc8564::readTime(uint8_t *hur, uint8_t *min, uint8_t *sec, uint8_t bcdflg) {

	Wire.beginTransmission(slaveAddress);
	Wire.write(rgSEC);			// 擪AhXݒ
	Wire.endTransmission();

	Wire.requestFrom(slaveAddress, 3);
	if(bcdflg) {
		// BCDR[h
		*sec = Wire.read() & 0x7F;
		*min = Wire.read() & 0x7F;
		*hur = Wire.read() & 0x3F;
	} else {
		// ̓oCi
		*sec = BcdToBin( Wire.read() & 0x7F );
		*min = BcdToBin( Wire.read() & 0x7F );
		*hur = BcdToBin( Wire.read() & 0x3F );
	}
}


//-----------------------------------------------------------
// A[ ݒ
//-----------------------------------------------------------
void wI2cRtc8564::setAlarm(uint8_t day, uint8_t hur, uint8_t min, uint8_t bcdflg) {

	Wire.beginTransmission(slaveAddress);
	Wire.write(rgALMMIN);		// WX^AhXݒ
	if(bcdflg) {
		// BCDR[h
		Wire.write(min);
		Wire.write(hur);
		Wire.write(day);
	} else {
		// ̓oCi
		Wire.write( BinToBcd(min) );
		Wire.write( BinToBcd(hur) );
		Wire.write( BinToBcd(day) );
	}
	Wire.endTransmission();
}


//-----------------------------------------------------------
// A[ ݒǏo
//-----------------------------------------------------------
void wI2cRtc8564::readAlarm(uint8_t *day, uint8_t *hur, uint8_t *min, uint8_t bcdflg) {
	uint8_t wkd;

	// A[ݒlǂݏo
	Wire.beginTransmission(slaveAddress);
	Wire.write(rgALMMIN);				// WX^AhXݒ
	Wire.endTransmission();

	Wire.requestFrom(slaveAddress, 4);
	if(bcdflg) {
		// BCDR[h
		*min = Wire.read();
		*hur = Wire.read();
		*day = Wire.read();
		wkd  = Wire.read();		// gȂ
	} else {
		// ̓oCi
		*min = BcdToBin( Wire.read() );
		*hur = BcdToBin( Wire.read() );
		*day = BcdToBin( Wire.read() );
		wkd  = BcdToBin( Wire.read() );		// gȂ
	}
}


//-----------------------------------------------------------
// A[`FbN
//	ret:
//		A[=true / A[=false
//-----------------------------------------------------------
uint8_t wI2cRtc8564::checkAlarm(void) {
	uint8_t sts;

	Wire.beginTransmission(slaveAddress);
	Wire.write(rgCTRL2);			// 擪AhXݒ
	Wire.endTransmission();

	Wire.requestFrom(slaveAddress, 1);
	sts = Wire.read() & 0x08;		// AF(b3)

	return sts;					// 0=A[A!0=A[
}



//-----------------------------------------------------------
// NbNo͒[q gݒ
//	in:
//		CLKOUT_1Hz		1
//		CLKOUT_32Hz		2
//		CLKOUT_1024Hz	3
//		CLKOUT_32768Hz	4
//		CLKOUT_DISABLE	0
//-----------------------------------------------------------
void wI2cRtc8564::setClkOut(uint8_t frq) {
	uint8_t fd;

	switch(frq) {
		case CLKOUT_1Hz:		// 1Hz NbNo
			fd = 0x83;
			break;
		case CLKOUT_32Hz:		// 32Hz NbNo
			fd = 0x82;
			break;
		case CLKOUT_1024Hz:		// 1024Hz NbNo
			fd = 0x81;
			break;
		case CLKOUT_32768Hz:	// 32768Hz NbNo
			fd = 0x80;
			break;
		default:				// NbNo͂Ȃ
			fd = 0x00;
			break;
	}

	writeReg(rgCOFREQ, fd);
}


//-----------------------------------------------------------
//	A[Lڂ̐ݒ
//		1̍ڂA[r, 0̍ڂ͕s
//-----------------------------------------------------------
void wI2cRtc8564::AlmEnable(uint8_t wkd, uint8_t day, uint8_t hur, uint8_t min) {

	uint8_t alm_wkd, alm_day, alm_hur, alm_min;

	// A[ݒlǂݏo
	Wire.beginTransmission(slaveAddress);
	Wire.write(rgALMMIN);				// WX^AhXݒ
	Wire.endTransmission();

	Wire.requestFrom(slaveAddress, 4);
	alm_min = Wire.read();
	alm_hur = Wire.read();
	alm_day = Wire.read();
	alm_wkd = Wire.read();

	if(min) {
		alm_min &= ~0x80;
	} else {
		alm_min |= 0x80;		// s
	}

	if(hur) {
		alm_hur &= ~0x80;
	} else {
		alm_hur |= 0x80;
	}

	if(day) {
		alm_day &= ~0x80;
	} else {
		alm_day |= 0x80;
	}

	if(wkd) {
		alm_wkd &= ~0x80;
	} else {
		alm_wkd |= 0x80;
	}

	// A[ݒl߂
	Wire.beginTransmission(slaveAddress);
	Wire.write(rgALMMIN);			// WX^AhXݒ
	Wire.write(alm_min);
	Wire.write(alm_hur);
	Wire.write(alm_day);
	Wire.write(alm_wkd);
	Wire.endTransmission();
}



//-----------------------------------------------------------
//	A[~
//-----------------------------------------------------------
void wI2cRtc8564::AlmStop(void) {
	uint8_t ctrl2;

	readReg(rgCTRL2, &ctrl2);

	ctrl2 &= ~0x08;				// AF(b3) clear
	writeReg(rgCTRL2, ctrl2);
}


//-----------------------------------------------------------
//	WX^ǂݏo
//-----------------------------------------------------------
uint8_t wI2cRtc8564::readReg(uint8_t adrs, uint8_t *dat) {
	Wire.beginTransmission(slaveAddress);
	Wire.write(adrs);				// WX^AhXݒ
	Wire.endTransmission();

	Wire.requestFrom(slaveAddress, 1);
	*dat = Wire.read();	// WX^ǂݏo
	Wire.endTransmission();
	return true;				// 
}


//-----------------------------------------------------------
//	WX^
//-----------------------------------------------------------
uint8_t wI2cRtc8564::writeReg(uint8_t adrs, uint8_t dat) {
	Wire.beginTransmission(slaveAddress);
	Wire.write(adrs);				// WX^AhXݒ
	Wire.write(dat);				// WX^
	Wire.endTransmission();
	return true;				// 
}



// 0`99̒l2BCDl֕ϊ
uint8_t wI2cRtc8564::BinToBcd(uint8_t num) {
	uint8_t val1, val2;

	val1 = num / 10;
	val2 = num % 10;

	return (val1 << 4) + val2;
}


// 2BCDloCil(0`99)֕ϊ
uint8_t wI2cRtc8564::BcdToBin(uint8_t num) {
	uint8_t val1, val2;

	val1 = (num >> 4) * 10;
	val2 = num & 0x0F;

	return val1 + val2;
}


