//
// MPC2515 レジスタ定義
//		copyright (c) 2008-2013 T.Nakao    http://www.wsnak.com
//
// 	08/12/28
//

#ifndef MCP2515REG_H
#define MCP2515REG_H

// -----------------------------------------
// レジスタ・アドレス
// -----------------------------------------
#define CAN_CNF1	0x2A	// コンフィギュレーション1レジスタ
#define CAN_CNF2	0x29	// コンフィギュレーション2レジスタ
#define CAN_CNF3	0x28	// コンフィギュレーション3レジスタ
#define CANCTRL		0x0F	// CANコントロール・レジスタ
#define CANSTAT		0x0E	// CANステータス・レジスタ
#define CANINTE		0x2B	// 割り込み許可レジスタ
#define CANINTF		0x2C	// 割り込みフラグ・レジスタ
#define EFLG		0x2D	// エラー・フラグ

// 送信バッファ0
#define TXB0CTRL	0x30	// 送信バッファ0 コントロール・レジスタ
#define TXB0SIDH	0x31	// 送信バッファ0 標準ID HIGH
#define TXB0SIDL	0x32	// 送信バッファ0 標準ID LOW
#define TXB0EID8	0x33	// 送信バッファ0 拡張ID HIGH
#define TXB0EID0	0x34	// 送信バッファ0 拡張ID LOW
#define TXB0DLC		0x35	// 送信バッファ0 DLC (データ長コード)レジスタ
#define TXB0D0		0x36	// 送信バッファ0 D0(先頭アドレス)

// 送信バッファ1
#define TXB1CTRL	0x40	// 送信バッファ1 コントロール・レジスタ
#define TXB1SIDH	0x41	// 送信バッファ1 標準ID HIGH
#define TXB1SIDL	0x42	// 送信バッファ1 標準ID LOW
#define TXB1EID8	0x43	// 送信バッファ1 拡張ID HIGH
#define TXB1EID0	0x44	// 送信バッファ1 拡張ID LOW
#define TXB1DLC		0x45	// 送信バッファ1 DLC (データ長コード)レジスタ
#define TXB1D0		0x46	// 送信バッファ1 D0(先頭アドレス)

// 送信バッファ2
#define TXB2CTRL	0x50	// 送信バッファ2 コントロール・レジスタ
#define TXB2SIDH	0x51	// 送信バッファ2 標準ID HIGH
#define TXB2SIDL	0x52	// 送信バッファ2 標準ID LOW
#define TXB2EID8	0x53	// 送信バッファ2 拡張ID HIGH
#define TXB2EID0	0x54	// 送信バッファ2 拡張ID LOW
#define TXB2DLC		0x55	// 送信バッファ2 DLC (データ長コード)レジスタ
#define TXB2D0		0x56	// 送信バッファ2 D0(先頭アドレス)

#define TXRTSCTRL	0x0D	// TXnRTSピン コントロール、ステータス



// 受信バッファ0
#define RXB0CTRL	0x60	// 受信バッファ0 コントロール・レジスタ
#define RXB0SIDH	0x61	// 受信バッファ0 標準ID HIGH
#define RXB0SIDL	0x62	// 受信バッファ0 標準ID LOW
#define RXB0EID8	0x63	// 受信バッファ0 拡張ID HIGH
#define RXB0EID0	0x64	// 受信バッファ0 拡張ID LOW
#define RXB0DLC		0x65	// 受信バッファ0 DLC (データ長コード)レジスタ
#define RXB0D0		0x66	// 受信バッファ0 D0(先頭アドレス)

// 受信バッファ1
#define RXB1CTRL	0x70	// 受信バッファ1 コントロール・レジスタ
#define RXB1SIDH	0x71	// 受信バッファ1 標準ID HIGH
#define RXB1SIDL	0x72	// 受信バッファ1 標準ID LOW
#define RXB1EID8	0x73	// 受信バッファ1 拡張ID HIGH
#define RXB1EID0	0x74	// 受信バッファ1 拡張ID LOW
#define RXB1DLC		0x75	// 受信バッファ1 DLC (データ長コード)レジスタ
#define RXB1D0		0x76	// 受信バッファ1 D0(先頭アドレス)

#define BFPCTRL		0x0C	// BFCTRL RXnBFピン コントロール,ステータス


// フィルタ0
#define RXF0SIDH	0x00	// フィルタ0標準ID HIGH
#define RXF0SIDL	0x01	// フィルタ0標準ID LOW
#define RXF0EID8	0x02	// フィルタ0拡張ID HIGH
#define RXF0EID0	0x03	// フィルタ0拡張ID LOW

// フィルタ1
#define RXF1SIDH	0x04	// フィルタ1標準ID HIGH
#define RXF1SIDL	0x05	// フィルタ1標準ID LOW
#define RXF1EID8	0x06	// フィルタ1拡張ID HIGH
#define RXF1EID0	0x07	// フィルタ1拡張ID LOW

// フィルタ2
#define RXF2SIDH	0x08	// フィルタ2標準ID HIGH
#define RXF2SIDL	0x09	// フィルタ2標準ID LOW
#define RXF2EID8	0x0A	// フィルタ2拡張ID HIGH
#define RXF2EID0	0x0B	// フィルタ2拡張ID LOW

// フィルタ3
#define RXF3SIDH	0x10	// フィルタ3標準ID HIGH
#define RXF3SIDL	0x11	// フィルタ3標準ID LOW
#define RXF3EID8	0x12	// フィルタ3拡張ID HIGH
#define RXF3EID0	0x13	// フィルタ3拡張ID LOW

// フィルタ4
#define RXF4SIDH	0x14	// フィルタ4標準ID HIGH
#define RXF4SIDL	0x15	// フィルタ4標準ID LOW
#define RXF4EID8	0x16	// フィルタ4拡張ID HIGH
#define RXF4EID0	0x17	// フィルタ4拡張ID LOW

// フィルタ5
#define RXF5SIDH	0x18	// フィルタ5標準ID HIGH
#define RXF5SIDL	0x19	// フィルタ5標準ID LOW
#define RXF5EID8	0x1A	// フィルタ5拡張ID HIGH
#define RXF5EID0	0x1B	// フィルタ5拡張ID LOW


// マスク0
#define RXM0SIDH	0x20	// マスク0標準ID HIGH
#define RXM0SIDL	0x21	// マスク0標準ID LOW
#define RXM0EID8	0x22	// マスク0拡張ID HIGH
#define RXM0EID0	0x23	// マスク0拡張ID LOW

// マスク1
#define RXM1SIDH	0x24	// マスク1標準ID HIGH
#define RXM1SIDL	0x25	// マスク1標準ID LOW
#define RXM1EID8	0x26	// マスク1拡張ID HIGH
#define RXM1EID0	0x27	// マスク1拡張ID LOW

// CANバス エラー・カウンタ
#define TEC			0x1C
#define REC			0x1D




// -----------------------------------------
// レジスタ・ビット・ロケーション
// -----------------------------------------

// CNF1 コンフィギュレーション1レジスタ (0x2A)
enum t_CNF1 {
	SJW1 = 7,		// b7
	SJW0 = 6,		// b6
	BRP5 = 5,		// b5
	BRP4 = 4,		// b4
	BRP3 = 3,		// b3
	BRP2 = 2,		// b2
	BRP1 = 1,		// b1
	BRP0 = 0		// b0
};

// CNF2 コンフィギュレーション2レジスタ (0x29)
enum t_CNF2 {
	BTLMODE = 7,	// b7
	SAM	= 6,		// b6
	PHSEG12 = 5,	// b5
	PHSEG11 = 4,	// b4
	PHSEG10 = 3,	// b3
	PRSEG2 = 2,		// b2
	PRSEG1 = 1,		// b1
	PRSEG0 = 0,		// b0
};

// CNF3 コンフィギュレーション3レジスタ (0x28)
enum t_CNF3 {
	SOF = 7,		// b7
	WAKFIL = 6,		// b6
	b5 = 5,			// b5
	b4 = 4,			// b4
	b3 = 3,			// b3
	PHSEG22 = 2,	// b2
	PHSEG21 = 1,	// b1
	PHSEG20 = 0		// b0
};

// CANCTRL CANコントロール・レジスタ (0xXF)
enum t_CANCTRL {
	REQOP2 = 7,		// b7
	REQOP1 = 6,		// b6
	REQOP0 = 5,		// b5
	ABAT = 4,		// b4
	OSM = 3,		// b3
	CLKEN = 2,		// b2
	CLKPRE1 = 1,	// b1
	CLKPRE0 = 0		// b0
};

// CANSTAT CANステータス・レジスタ (0xXE)
enum t_CANSTAT {
	OPMOD2 = 7,		// b7
	OPMOD1 = 6,		// b6
	OPMOD0 = 5,		// b5
//	b4 = 4,			// b4
	ICOD2 = 3,		// b3
	ICOD1 = 2,		// b2
	ICOD0 = 1,		// b1
//	b0 = 0			// b0
};

// CANINTE 割り込み許可レジスタ (0x2B)
enum t_CANINTE {
	MERRE = 7,		// b7
	WAKIE = 6,		// b6
	ERRIE = 5,		// b5
	TX2IE = 4,		// b4
	TX1IE = 3,		// b3
	TX0IE = 2,		// b2
	RX1IE = 1,		// b1
	RX0IE = 0,		// b0
};

// CANINTF 割り込みフラグ・レジスタ (0x2C)
enum t_CANINTF {
	MERRF = 7,		// b7
	WAKIF = 6,		// b6
	ERRIF = 5,		// b5
	TX2IF = 4,		// b4
	TX1IF = 3,		// b3
	TX0IF = 2,		// b2
	RX1IF = 1,		// b1
	RX0IF = 0		// b0
};

// EFLG エラー・フラグ (0x2D)
enum t_EFLG {
	RX1OVR = 7,		// b7
	RX0OVR = 6,		// b6
	TXBO = 5,		// b5
	TXEP = 4,		// b4
	RXEP = 3,		// b3
	TXWAR = 2,		// b2
	RXWAR = 1,		// b1
	EWARN = 0		// b0
};

// TXBnCTRL 送信バッファn コントロール・レジスタ (n = 0, 1, 2) (0x30, 0x40, 0x50)
enum t_TXBnCTRL {
//	b7 = 7,			// b7
	ABTF = 6,		// b6
	MLOA = 5,		// b5
	TXERR = 4,		// b4
	TXREQ = 3,		// b3
//	b3 = 2,			// b2
	TXP1 = 1,		// b1
	TXP0 = 0		// b0

};

// TXBnDLC 送信バッファn DLCレジスタ(n = 0, 1, 2) (0x35, 0x45, 0x55)
enum t_TXBnDLC {
//	b7 = 7,			// b7
	RTR = 6,		// b6
//	b5 = 5,			// b5
//	b4 = 4,			// b4
	DLC3 = 3,		// b3
	DLC2 = 2,		// b2
	DLC1 = 1,		// b1
	DLC0 = 0		// b0

};

// RXB0CTRL 受信バッファ0 コントロール・レジスタ (0x60)
enum t_RXB0CTRL {
//	b7 = 7,			// b7
	RXM1 = 6,		// b6
	RXM0 = 5,		// b5
//	b4 = 4,			// b4
	RXRTR = 3,		// b3
	BUKT = 2,		// b2
	BUKT1 = 1,		// b1
	FILHIT0 = 0,	// b0
};

// RXBnDLC 受信バッファn DLCレジスタ(n = 0, 1) (0x65, 0x75)
enum t_RXBnDLC {
//	b7 = 7,			// b7
//	RTR = 6,		// b6
	RB1 = 5,		// b5
	RB0 = 4,		// b4
//	DLC3 = 3,		// b3
//	DLC2 = 2,		// b2
//	DLC1 = 1,		// b1
//	DLC0 = 0		// b0
};

// RXB1CTRL 受信バッファ1 コントロール・レジスタ (0x70)
enum t_RXB1CTRL {
//	b7 = 7,			// b7
//	RXM1 = 6,		// b6
//	RXM0 = 5,		// b5
//	b4 = 4,			// b4
//	RXRTR = 3,		// b3
	FILHIT2 = 2,	// b2
	FILHIT1 = 1,	// b1
//	FILHIT0 = 0		// b0
};

// TXnRTSピン コントロール、ステータス
enum t_TXRTSCTRL {
//	b7 = 7,			// b7
//	b6 = 6,			// b6
	B2RTS = 5,
	B1RTS = 4,
	B0RTS = 3,
	B2RTSM = 2,
	B1RTSM = 1,
	B0RTSM = 0
};

// BFCTRL RXnBFピン コントロール,ステータス
enum t_BFPCTRL {
//	b7 = 7,			// b7
//	b6 = 6,			// b6
	B1BFS = 5,
	B0BFS = 4,
	B1BFE = 3,
	B0BFE = 2,
	B1BFM = 1,
	B0BFM = 0
};

// RXFnSIDL フィルタn標準ID LOW (n = 0, 1, 2, 3, 4, 5)
// (アドレス：0x01, 0x05, 0x09, 0x11, 0x15, 0x19)
#define EXIDE	3	// b3: 拡張ID許可ビット
					//   1 = 拡張ID(29ビット)のみに適用
					//   0 = 標準ID(11ビット)のみに適用

// TXBnSIDL 送信バッファn標準ID LOW (n = 0, 1, 2)
// (アドレス：0x32, 0x42, 0x52)

//#define EXIDE	3	// 拡張ID許可ビット
					//   1 = 拡張ID(29ビット)
					//   0 = 標準ID(11ビット)

// RXBnSIDL 受信バッファn標準ID LOW (n = 0, 1)
// (アドレス：0x62, 0x72)

#define SRR		4	// 標準フレーム・リモート送信要求
					//   IDE"が0のときのみ有効
					//     1 = 標準フレームのリモート送信要求を受信
					//     0 = 標準データフレームを受信

#define IDE		3	// 受信IDのフォーマット
					//   1 = 拡張ID(29ビット)
					//   0 = 標準ID(11ビット)



#endif
