//
//	Cu "wCan2515"
//		copyright (c) 2010-2013 T.Nakao    http://www.wsnak.com
//
//		10/05/ xxx
//

#ifndef wCan2515_h
#define wCan2515_h

#include <inttypes.h>


// SPI|[g rbg
#define CAN_SPI_CS_H	digitalWrite(pinSs, HIGH)
#define CAN_SPI_SO_H	digitalWrite(pinSo, HIGH)
#define CAN_SPI_SCK_H	digitalWrite(pinSck, HIGH)

#define CAN_SPI_CS_L	digitalWrite(pinSs, LOW)
#define CAN_SPI_SO_L	digitalWrite(pinSo, LOW)
#define CAN_SPI_SCK_L	digitalWrite(pinSck, LOW)

#define CAN_SPI_SI		digitalRead(pinSi)

// CANrbg[g
#define CAN_BRP_16MHz_500KBPS	0			// FOSC=16MHz
#define CAN_BRP_16MHz_250KBPS	1			// FOSC=16MHz
#define CAN_BRP_16MHz_125KBPS	3			// FOSC=16MHz


// SPIR}h CXgNV
#define SPI_INST_RESET		0xC0
#define SPI_INST_READ		0x03
#define SPI_INST_WRITE		0x02
#define SPI_INST_RD_RXBUF	0xC0
#define SPI_INST_LD_TXBUF	0x40
#define SPI_INST_RTS		0x80
#define SPI_INST_RD_STAT	0xA0
#define SPI_INST_RX_STAT	0xB0
#define SPI_INST_BIT_MOD	0x05

// ^Mobt@ V[PVE[h^Cg CXgNV
#define RD_RXBUF_RXB0SIDH	0x90
#define RD_RXBUF_RXB0D0		0x92
#define RD_RXBUF_RXB1SIDH	0x94
#define RD_RXBUF_RXB1D0		0x96
#define LD_TXBUF_TXB0SIDH	0x40
#define LD_TXBUF_TXB0D0		0x41
#define LD_TXBUF_TXB1SIDH	0x42
#define LD_TXBUF_TXB1D0		0x43
#define LD_TXBUF_TXB2SIDH	0x44
#define LD_TXBUF_TXB2D0		0x45

// *********** CAN hCoi}Nj ************

// Iy[VE[h CANCTRL/CANSTAT
#define CAM_MODE_NORMAL		0
#define CAM_MODE_SLEEP		1
#define CAM_MODE_LOOPBACK	2
#define CAM_MODE_LISTEN		3
#define CAM_MODE_CONFIG		4


// tB^E[h̐ݒ
// mode
#define FILTER_MOD_ALL_HIT 3		// }XNAtB^gp
#define FILTER_MOD_SID_HIT 1		// SIDŃ}XNAtB^Kp


#define MASK_SID_ALL_HIT   0x0000		// ׂă}XN
#define MASK_SID_CPL_MATCH 0x07FF		// }XN Sv

// SIDWX^l}N
#define GET_SIDH(msg) (byte)(msg >> 3)
#define GET_SIDL(msg) (byte)(msg << 5)
#define MAKE_SID(sid_h, sid_l) ((unsigned int)sid_h<<3)|(sid_l>>5)


// SPIR}h MXe[^X\(MXe[^XE[hER}h)
struct tag_RXSTAT {
	unsigned char FilterMatch:3;		// b0-b2 qbgtB^̔ԍ
	unsigned char RemoteFrm:1;		// b3 (1)[gEt[/(0)f[^Et[
	unsigned char ExtMsg:1;			// b4 (1)gID/(0)WID
	unsigned char b5:1;				// b5
	unsigned char MsgInRXB0:1;		// b6 RXB0ɃbZ[W
	unsigned char MsgInRXB1:1;		// b7 RXB1ɃbZ[W
};

enum t_RXSTAT {
	FilterMatch0 = 0,		// b0 qbgtB^̔ԍ
	FilterMatch1 = 1,		// b1 qbgtB^̔ԍ
	FilterMatch2 = 2,		// b2 qbgtB^̔ԍ
	RemoteFrm = 3,			// b3 (1)[gEt[/(0)f[^Et[
	ExtMsg = 4,				// b4 (1)gID/(0)WID
//	b5 = 5,					// b5
	MsgInRXB0 = 6,			// b6 RXB0ɃbZ[W
	MsgInRXB1 = 7			// b7 RXB1ɃbZ[W
};


class wCan2515
{
public:
	wCan2515(uint8_t sck, uint8_t si, uint8_t so, uint8_t ss, uint8_t rate);
													// RXgN^i|[gԍݒj

	void Reset(void);			// CANRg[MCP2515 \tgEFAEZbg
	void Init(uint8_t rate);						// CANRg[MCP2515̏

	void SetMask(uint8_t mask_num, uint16_t sid);	// MID}XN̐ݒ
	void SetMask(uint16_t sid);						// MID}XN̐ݒimask0pj
	void SetFilter(uint8_t filter_num, uint16_t sid);// MIDtB^̐ݒ
	void SetFilter(uint16_t sid);					// MIDtB^̐ݒifilter0pj

	void SetFilterMode(uint8_t buf_num, uint8_t mode);	// tB^E[h̐ݒ

	// bZ[Wƃf[^𑗐Mobt@֏
	void SetTxBuf(uint8_t buf_num, uint8_t dat_siz);
	void SetTxBuf(uint8_t buf_num, uint16_t message,
				uint8_t dat[8], uint8_t dat_siz, uint8_t dtfam = true);

	// Mobt@烁bZ[Wƃf[^ǂݏo
	uint16_t GetRxBuf(uint8_t buf_num, uint8_t dat[14], uint8_t *size, uint8_t *dtfam);

	void TxReq(uint8_t buf_num);					// Mv
	uint8_t CheckTxComp(uint8_t buf_num);			// M`FbN

	// v~eBu\bh
	uint8_t SpiRW(uint8_t outdat);					// SPI 1oCg[h/Cg
	uint8_t RxCheck(uint8_t rxbnum = 2);			// CANM`FbN
	void	SetOpMode(uint8_t mode);				// CANRg[ [hݒ

	void    WriteReg(uint8_t adrs, uint8_t data);	// CANWX^ oCgECg
	uint8_t RegRead2B(uint8_t inst, uint8_t adrs);	// CANWX^/Xe[^XE[h
	uint8_t ReadReg(uint8_t adrs);					// WX^ oCgE[h
	uint8_t ReadStat(void);							// Xe[^XE[h
	uint8_t ReadRXStat(void);						// MXe[^XE[h
	void    BitModCmd(uint8_t adrs, uint8_t mask, uint8_t data);
													// CANrbgEft@CER}h

	void TxRxBufRW(uint8_t inst, uint8_t readop, uint8_t *data, uint8_t cnt);
				// CAN^Mobt@ V[PVE[h^Cg

	// nho^
	void OnReceive(void (*)(uint8_t));		// CANMnho^
	void OnTxComp0(void (*)(void));			// CANMnho^
	void OnTxComp1(void (*)(void));			// CANMnho^
	void OnTxComp2(void (*)(void));			// CANMnho^

	void onReceive(void (*)(uint8_t));
	void onTxComp0(void (*)(void));
	void onTxComp1(void (*)(void));
	void onTxComp2(void (*)(void));

//	uint8_t TxBuf[14];				// MbZ[WAf[^pobt@
//	uint8_t RxBuf[14];				// MbZ[WAf[^pobt@

	uint8_t txBuf[14];				// MbZ[WAf[^pobt@
	uint8_t rxBuf[14];				// MbZ[WAf[^pobt@


	// ----------------- inline֐ ------------------------
	void reset(void);
	void init(uint8_t rate);
	void setMask(uint8_t mask_num, uint16_t sid);
	void setMask(uint16_t sid);
	void setFilter(uint8_t filter_num, uint16_t sid);
	void setFilter(uint16_t sid);
	void setFilterMode(uint8_t buf_num, uint8_t mode);
	void setTxBuf(uint8_t buf_num, uint8_t dat_siz);
	void setTxBuf(uint8_t buf_num, uint16_t message,
				uint8_t dat[8], uint8_t dat_siz, uint8_t dtfam = true);
	uint16_t getRxBuf(uint8_t buf_num, uint8_t dat[14], uint8_t *size, uint8_t *dtfam);
	void txReq(uint8_t buf_num);
	uint8_t checkTxComp(uint8_t buf_num);
	uint8_t spiRW(uint8_t outdat);
	uint8_t rxCheck(uint8_t rxbnum = 2);
	void setOpMode(uint8_t mode);
	void writeReg(uint8_t adrs, uint8_t data);
	uint8_t regRead2B(uint8_t inst, uint8_t adrs);
	uint8_t readReg(uint8_t adrs);
	uint8_t readStat(void);
	uint8_t readRXStat(void);
	void bitModCmd(uint8_t adrs, uint8_t mask, uint8_t data);
	void txRxBufRW(uint8_t inst, uint8_t readop, uint8_t *data, uint8_t cnt);

private:

	// nhR[
	static void (*user_onReceive)(uint8_t rslt);
	static void (*user_onTxComp0)(void);
	static void (*user_onTxComp1)(void);
	static void (*user_onTxComp2)(void);

	// Arduino fW^|[g_ԍ
	uint8_t pinSck;
	uint8_t pinSi;
	uint8_t pinSo;
	uint8_t pinSs;

	uint8_t _tx_pend[3];
};



// ----------------------------------------------------------------------
// 擪ɂCC֐

inline void wCan2515::reset(void) {
	Reset();
}

inline void wCan2515::init(uint8_t rate) {
	Init(rate);
}

inline void wCan2515::setMask(uint8_t mask_num, uint16_t sid) {
	SetMask(mask_num, sid);
}

inline void wCan2515::setMask(uint16_t sid) {
	SetMask(sid);
}

inline void wCan2515::setFilter(uint8_t filter_num, uint16_t sid) {
	SetFilter(filter_num, sid);
}

inline void wCan2515::setFilter(uint16_t sid) {
	SetFilter(sid);
}

inline void wCan2515::setFilterMode(uint8_t buf_num, uint8_t mode) {
	SetFilterMode(buf_num, mode);
}

	// bZ[Wƃf[^𑗐Mobt@֏
inline void wCan2515::setTxBuf(uint8_t buf_num, uint8_t dat_siz) {
	SetTxBuf(buf_num, dat_siz);
}

inline void wCan2515::setTxBuf(uint8_t buf_num, uint16_t message,
				uint8_t dat[8], uint8_t dat_siz, uint8_t dtfam) {
	SetTxBuf(buf_num, message, dat, dat_siz, dtfam);
}

inline uint16_t wCan2515::getRxBuf(uint8_t buf_num, uint8_t dat[14], uint8_t *size, uint8_t *dtfam) {
	return GetRxBuf(buf_num, dat, size, dtfam);
}

inline void wCan2515::txReq(uint8_t buf_num) {
	TxReq(buf_num);
}

inline uint8_t wCan2515::checkTxComp(uint8_t buf_num) {
	return CheckTxComp(buf_num);
}


inline uint8_t wCan2515::spiRW(uint8_t outdat) {
	return SpiRW(outdat);
}

inline uint8_t wCan2515::rxCheck(uint8_t rxbnum) {
	return RxCheck(rxbnum);
}

inline void	wCan2515::setOpMode(uint8_t mode) {
	SetOpMode(mode);
}

inline void wCan2515::writeReg(uint8_t adrs, uint8_t data) {
	WriteReg(adrs, data);
}

inline uint8_t wCan2515::regRead2B(uint8_t inst, uint8_t adrs) {
	return RegRead2B(inst, adrs);
}

inline uint8_t wCan2515::readReg(uint8_t adrs) {
	return ReadReg(adrs);
}

inline uint8_t wCan2515::readStat(void) {
	return ReadStat();
}

inline uint8_t wCan2515::readRXStat(void) {
	return ReadRXStat();
}

inline void wCan2515::bitModCmd(uint8_t adrs, uint8_t mask, uint8_t data) {
	BitModCmd(adrs, mask, data);
}

inline void wCan2515::txRxBufRW(uint8_t inst, uint8_t readop, uint8_t *data, uint8_t cnt) {
	TxRxBufRW(inst, readop, data, cnt);
}


#endif
