//
// I2C化 40x4 サンプルプログラム
//		copyright (c) 2012,2013 T.Nakao    http://www.wsnak.com
//
//  12/05/10
//

#include <Wire.h>             // I2C
#include <wDisplay.h>   //

// インスタンス生成
wI2cLcd lcd404(LCD_8BITMODE);         // 40文字×4行タイプ

/*
  I2Cスレーブアドレス
    I2C化LCD(40文字×4行型) 0x30

*/

byte Flag = false;

void setup(void) {
  Wire.begin();               // I2C初期化
  lcd404.begin(40, 4, 0x30);

  // 全クリア
  lcd404.selectArea(2);     // 両エリア指定
  lcd404.clear();           // 全クリア

	delay(1000);

  // 文字列表示
  lcd404.selectArea(0);     // エリア0指定
  lcd404.print("C51549");
  lcd404.selectArea(1);     // エリア1指定
  lcd404.print("40x4");

	delay(1000);

  // カーソル位置指定
  lcd404.setCursor(5, 1, 2);  // 両エリア
  lcd404.print("TEST03");  // 文字列表示

	delay(1000);

  lcd404.setCursor(12, 1, 0);  // 両エリア
  lcd404.print("UPPER");

	delay(1000);

  lcd404.setCursor(12, 1, 1);  // 両エリア
  lcd404.print("LOWER");

  delay(1000);

  byte i;
  lcd404.selectArea(2);       // 両エリア選択
  lcd404.clear();             // 全クリア

  lcd404.setCursor(0, 0);
  for(i = 0; i < 40; i++) {
    delay(100);
    lcd404.print(i%10);
  }

  lcd404.setCursor(0, 1);
  for(i = 0; i < 40; i++) {
    lcd404.print(i%10);
  }

  delay(1000);

  lcd404.selectArea(0);        // エリア0選択
  Flag = true;
}


void loop(void) {
  if(Flag) {
    lcd404.display();
    delay(500);
    lcd404.noDisplay();
    delay(500);
  }
}

