//
//  Cu "wD7S4Led" 47ZOgLED\hCo
//		copyright (c) 2012,2013 T.Nakao    http://www.wsnak.com
//
//      12/03/18
//
//      120511 wLT,}CiXp^[ǉ
//  	120512 [TvX̐ݒ莞ɐlf[^̍Đݒ肪svɂȂ悤C
//
//

#include <avr/io.h>
#include "wD7S4Led.h"

//#include "WProgram.h"     // o[W
#include "Arduino.h"        // Vo[W

// RXgN^
wD7S4Led::wD7S4Led(void)
{
    // D0`D7o͂ɐݒ
    DDRD = 0xFF;    // D0-D7 output
    DDRB |= 0x0F;   // D8-D11 output

                        // Pgfedcba
    segPat[0] = 0x3F;   // 00111111 0
    segPat[1] = 0x06;   // 00000110 1
    segPat[2] = 0x5B;   // 01011011 2
    segPat[3] = 0x4F;   // 01001111 3
    segPat[4] = 0x66;   // 01100110 4
    segPat[5] = 0x6D;   // 01101101 5
    segPat[6] = 0x7D;   // 01111101 6
    segPat[7] = 0x07;   // 00000111 7
    segPat[8] = 0x7F;   // 01111111 8
    segPat[9] = 0x67;   // 01100111 9
                        // Pgfedcba		120511ǉ
    segPat[10] = 0x77;  // 01110111 A
    segPat[11] = 0x7C;  // 01111100 b
    segPat[12] = 0x39;  // 00111001 C
    segPat[13] = 0x5E;  // 01011110 d
    segPat[14] = 0x79;  // 01111001 E
    segPat[15] = 0x71;  // 01110001 F
    segPat[16] = 0x40;  // 01000000 }CiX
    segPat[17] = 0x00;  // 00000000 uN

    init();
}


// 
void wD7S4Led::init(void) {
    onDelay = 4;        // ONԂ̃ftHgJEg
    offDelay = 1;       // OFFԂ̃ftHgJEg

    _seq_phase = 0;       // V[PX|C^
    _delay_count = onDelay;
    _all_off = false;

    // \f[^
    digit[0] = 0;
    digit[1] = 0;
    digit[2] = 0;
    digit[3] = 0;

    digRvs = false;         // ыt
    colRvs = true;
}


// _Ci~bN_JԂ
void wD7S4Led::process(void) {
    uint8_t colpat;
    uint8_t reg;

    if(_all_off) {
        // S\OFF
        if(colRvs) {
            OUT_COLDAT |= 0x0F;         // _(TrȂ) S"H"
        } else {
            OUT_COLDAT &= 0xF0;         // _(Tr莞) S"L"
        }
        return;
    }

    _delay_count--;
    if(_delay_count == 0) {
        // JE^^CAbv
        _seq_phase = (_seq_phase + 1) % 8;

        if(_seq_phase & 1) {
            // 1, 3, 5, 7
            // OFF
            // SOFF
            if(colRvs) {
                OUT_COLDAT |= 0x0F;         // _(TrȂ) S"H"
            } else {
                OUT_COLDAT &= 0xF0;         // _(Tr莞) S"L"
            }

            _delay_count = offDelay;
        } else {
            // 0, 2, 4, 6
            // ON
            _delay_count = onDelay;

            uint8_t sq = _seq_phase >> 1;

            // ZOgf[^o
            OUT_SEGDAT = digitPat[sq];

            // J؂ւ
            colpat = 1 << sq;

            if(colRvs) {
                colpat = (~colpat) & 0x0F;  // _(TrȂ)
            } else {
                colpat = colpat & 0x0F;     // _(Tr莞)
            }

            reg = OUT_COLDAT;               // o̓|[gb`ǂݏo
            reg &= 0xF0;                    // 4rbgNA
            reg |= colpat;                  // }[W
            OUT_COLDAT = reg;               // o̓|[g֏߂
        }
    }
}


// wʒȕ_̕\A
void wD7S4Led::setDP(uint8_t dp, uint8_t on_off) {

    uint8_t pt;

    if((dp < 1) || (4 < dp)) {
        return;
    }

    dp--;       // 0`3

    // _̃ZOg
    if(on_off) {
        digitPat[dp] |= 0x80;       // MSB set
    } else {
        digitPat[dp] &= ~0x80;      // MSB reset
    }
}


// S\A̐ݒ
void wD7S4Led::disp(uint8_t on_off) {
    if(on_off) {
        _all_off = false;         // ʏ\
    } else {
        _all_off = true;          // SOFF
    }
}


// \e(n=0`9999̐l)ݒ
void wD7S4Led::setNum(uint16_t num) {
    uint8_t dnum;
    uint16_t snum;
    uint8_t i;

    // ŏ0Ŗ߂Ă
    for(i = 0; i < 4; i++) {
        // [TvXȂ
        digit[i] = 0;           // ix=0 "0"
    }

    // 1000̌
    dnum = (uint8_t)(num / 1000);
    snum = num % 1000;
    digit[3] = dnum;

    // 100̌
    dnum = (uint8_t)(snum / 100);
    snum = snum % 100;
    digit[2] = dnum;

    // 10̌
    dnum = (uint8_t)(snum / 10);
    digit[1] = dnum;

    // 1̌
    dnum = (uint8_t)(snum % 10);
    digit[0] = dnum;

    // [TvX 120418
    if(_zero_sup) {
        // [TvX
        for(i = 3; i > 0; i--) {    // 3, 2, 1
            if(digit[i] == 0) {
                digit[i] = 17;      // ix=17 uN
            } else {
                break;
            }
        }
    }

    setSegPat();        // ZOgp^[ݒ
}


// ZOgp^[ݒ
void wD7S4Led::setSegPat(void) {
    // ZOgp^[ݒ
    uint8_t i, pat;

    if(digRvs) {
        // t
        for(i = 0; i < 4; i++) {
            pat = digitPat[i] & 0x80;           // MSB(DP)̂ݎc
            pat |= segPat[ digit[3-i] ];
            digitPat[i] = pat;
        }
    } else {
        for(i = 0; i < 4; i++) {
            pat = digitPat[i] & 0x80;           // MSB(DP)̂ݎc
            pat |= segPat[ digit[i] ];
            digitPat[i] = pat;
        }
    }
}


// [TvXL̐ݒ
void wD7S4Led::setZeroSup(uint8_t on_off) {
    uint8_t zero, i;

    if(on_off) {
        _zero_sup = true;
        // 0l߂Ȃ
        zero = 17;              // ix=17 uN
    } else {
        // 0l߂
        _zero_sup = false;
        zero = 0;               // ix=0 '0'
    }

    // ݂̕\XV 120512
    for(i = 3; i > 0; i--) {    // 3, 2, 1
        if( (digit[i] == 0) || (digit[i] == 17) ) {
            // 0܂̓uN
            digit[i] = zero;        //
        } else {
            // 0ȊO̐l
            break;
        }
    }
    setSegPat();
}


//
// 416il\ 120619ǉ
//
void wD7S4Led::dispHexaVal(uint16_t dat) {
	uint8_t i;
	uint16_t val;

	val = dat;
	for(i = 0; i < 4; i++) {			// ŉʌ
		digit[3 - i] = (byte)val & 0x0F;
		val >>= 4;						// ̌
	}
	setSegPat();

}


//
// 410il\ 120619ǉ
//
void wD7S4Led::dispBCDVal(uint16_t dat) {
	uint8_t i;
	uint16_t val, val2;

	val = dat;

	for(i = 0; i < 3; i++) {			// ŉʌ
		val2 = val % 10;
		val  = val / 10;
		digit[3 - i] = (byte)val2;
	}
	digit[0] = val;
	setSegPat();
}

