//
// 12/04/17 LiquidCrystalLCD C-51849NFJ-SLW-ADN 40~4spɃJX^}CY T.Nakao
// delay()͎gps
//

#include "wLcd404.h"		//

#include <stdio.h>
#include <string.h>
#include <inttypes.h>
#include "Arduino.h"


wLcd404::wLcd404(uint8_t rs, uint8_t e1, uint8_t e2,
			uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3,
			uint8_t d4, uint8_t d5, uint8_t d6, uint8_t d7)
{
	init(0, rs, e1, e2, d0, d1, d2, d3, d4, d5, d6, d7);
}


void wLcd404::init(uint8_t fourbitmode, uint8_t rs, uint8_t e1, uint8_t e2,
			 uint8_t d0, uint8_t d1, uint8_t d2, uint8_t d3,
			 uint8_t d4, uint8_t d5, uint8_t d6, uint8_t d7)
{
	_rs_pin = rs;
	_e1_pin = e1;	 // E1
	_e2_pin = e2;	 // E2

	_data_pins[0] = d0;
	_data_pins[1] = d1;
	_data_pins[2] = d2;
	_data_pins[3] = d3;
	_data_pins[4] = d4;
	_data_pins[5] = d5;
	_data_pins[6] = d6;
	_data_pins[7] = d7;

	pinMode(_rs_pin, OUTPUT);
	pinMode(_e1_pin, OUTPUT);
	pinMode(_e2_pin, OUTPUT);

	_displayfunction = LCD_8BITMODE | LCD_1LINE | LCD_5x8DOTS;

	begin(40, 2);  		// 40x4sΉ
	area_select = 2;	// ftHgݒGA1 40x4sΉ
}


void wLcd404::begin(uint8_t cols, uint8_t lines, uint8_t dotsize) {
	if (lines > 1) {
		_displayfunction |= LCD_2LINE;
	}
	_numlines = 2;		// lines;
	_currline = 0;

	// for some 1 line displays you can select a 10 pixel high font
	if ((dotsize != 0) && (lines == 1)) {
		_displayfunction |= LCD_5x10DOTS;
	}

	delayMicroseconds(50000);

	digitalWrite(_rs_pin, LOW);
	digitalWrite(_e1_pin, LOW);
	digitalWrite(_e2_pin, LOW);

	// Send function set command sequence
	command(LCD_FUNCTIONSET | _displayfunction);
	delayMicroseconds(5000);

	// second try
	command(LCD_FUNCTIONSET | _displayfunction);
	delayMicroseconds(150);

	// third go
	command(LCD_FUNCTIONSET | _displayfunction);

	// finally, set # lines, font size, etc.
	command(LCD_FUNCTIONSET | _displayfunction);

	// turn the display on with no cursor or blinking default
	_displaycontrol = LCD_DISPLAYON | LCD_CURSOROFF | LCD_BLINKOFF;

	display();
	clear();

	// Initialize to default text direction (for romance languages)
	_displaymode = LCD_ENTRYLEFT | LCD_ENTRYSHIFTDECREMENT;

	// set the entry mode
	command(LCD_ENTRYMODESET | _displaymode);
}


/********** high level commands, for the user! */
void wLcd404::clear()
{
	command(LCD_CLEARDISPLAY);	// clear display, set cursor position to zero
	delayMicroseconds(2000);  // this command takes a long time!
}


void wLcd404::home()
{
	command(LCD_RETURNHOME);  // set cursor position to zero
	delayMicroseconds(2000);  // this command takes a long time!
}


void wLcd404::setCursor(uint8_t col, uint8_t row)
{
	int row_offsets[] = { 0x00, 0x40, 0x14, 0x54 };
	if ( row >= _numlines ) {
		row = _numlines-1;	// we count rows starting w/0
	}

	command(LCD_SETDDRAMADDR | (col + row_offsets[row]));
}


// ---------------------------------------------
// GAݒtJ[\ʒuݒ 40x4sΉ
// ---------------------------------------------
void wLcd404::setCursor(uint8_t col, uint8_t row, uint8_t area) {
	selectArea(area);
	setCursor(col, row);
}


// Turn the display on/off (quickly)
void wLcd404::noDisplay() {
	_displaycontrol &= ~LCD_DISPLAYON;
	command(LCD_DISPLAYCONTROL | _displaycontrol);
}
void wLcd404::display() {
	_displaycontrol |= LCD_DISPLAYON;
	command(LCD_DISPLAYCONTROL | _displaycontrol);
}


// Turns the underline cursor on/off
void wLcd404::noCursor() {
	_displaycontrol &= ~LCD_CURSORON;
	command(LCD_DISPLAYCONTROL | _displaycontrol);
}
void wLcd404::cursor() {
	_displaycontrol |= LCD_CURSORON;
	command(LCD_DISPLAYCONTROL | _displaycontrol);
}


// Turn on and off the blinking cursor
void wLcd404::noBlink() {
	_displaycontrol &= ~LCD_BLINKON;
	command(LCD_DISPLAYCONTROL | _displaycontrol);
}
void wLcd404::blink() {
	_displaycontrol |= LCD_BLINKON;
	command(LCD_DISPLAYCONTROL | _displaycontrol);
}


// These commands scroll the display without changing the RAM
void wLcd404::scrollDisplayLeft(void) {
	command(LCD_CURSORSHIFT | LCD_DISPLAYMOVE | LCD_MOVELEFT);
}
void wLcd404::scrollDisplayRight(void) {
	command(LCD_CURSORSHIFT | LCD_DISPLAYMOVE | LCD_MOVERIGHT);
}


// This is for text that flows Left to Right
void wLcd404::leftToRight(void) {
	_displaymode |= LCD_ENTRYLEFT;
	command(LCD_ENTRYMODESET | _displaymode);
}


// This is for text that flows Right to Left
void wLcd404::rightToLeft(void) {
	_displaymode &= ~LCD_ENTRYLEFT;
	command(LCD_ENTRYMODESET | _displaymode);
}


// This will 'right justify' text from the cursor
void wLcd404::autoscroll(void) {
	_displaymode |= LCD_ENTRYSHIFTINCREMENT;
	command(LCD_ENTRYMODESET | _displaymode);
}


// This will 'left justify' text from the cursor
void wLcd404::noAutoscroll(void) {
	_displaymode &= ~LCD_ENTRYSHIFTINCREMENT;
	command(LCD_ENTRYMODESET | _displaymode);
}


// Allows us to fill the first 8 CGRAM locations
// with custom characters
void wLcd404::createChar(uint8_t location, uint8_t charmap[]) {
	location &= 0x7; // we only have 8 locations 0-7
	command(LCD_SETCGRAMADDR | (location << 3));

	for (int i = 0; i < 8; i++) {
		write(charmap[i]);
	}
}


/*********** mid level commands, for sending data/cmds */

inline void wLcd404::command(uint8_t value) {
	send(value, LOW);
}


inline size_t wLcd404::write(uint8_t value) {
	send(value, HIGH);

	return 1; // assume sucess
}


/************ low level data pushing commands **********/

// write either command or data, with automatic 4/8-bit selection
void wLcd404::send(uint8_t value, uint8_t mode) {
	digitalWrite(_rs_pin, mode);
	write8bits(value);
}


// ---------------------------------------------
// Xg[uo() 40x4sΉ
//	 0:Area1/1=Area2/2`=Area1,2
// ---------------------------------------------
void wLcd404::pulseEnable(void) {

	digitalWrite(_e1_pin, LOW);
	digitalWrite(_e2_pin, LOW);
	delayMicroseconds(1);

	if(area_select == 0) {
		// GA1
		digitalWrite(_e1_pin, HIGH);
	} else if(area_select == 1) {
		// GA2
		digitalWrite(_e2_pin, HIGH);
	} else {
		// GA12
		digitalWrite(_e1_pin, HIGH);
		digitalWrite(_e2_pin, HIGH);
	}

	delayMicroseconds(1);	 // enable pulse must be >450ns

	digitalWrite(_e1_pin, LOW);
	digitalWrite(_e2_pin, LOW);

	delayMicroseconds(100);   // commands need > 37us to settle
}


void wLcd404::write8bits(uint8_t value) {
	for (int i = 0; i < 8; i++) {
		pinMode(_data_pins[i], OUTPUT);
		digitalWrite(_data_pins[i], (value >> i) & 0x01);
	}

	pulseEnable();
}


// ---------------------------------------------
// GAEZNg 40x4sΉ
//	 0=Area1 / 1=Area2 / 2<=Area1,2
// ---------------------------------------------
void wLcd404::selectArea(uint8_t sw) {
	area_select = sw;	 // GAIϐɐݒ
}

